/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"bytes"
	"encoding/json"
	"fmt"
	"time"
)

// checks if the AccountProvider type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AccountProvider{}

// AccountProvider struct for AccountProvider
type AccountProvider struct {
	AccountProviderIdentifier NullableString `json:"accountProviderIdentifier,omitempty"`
	DisplayName               string         `json:"displayName"`
	Description               string         `json:"description"`
	LoaId                     NullableString `json:"loaId,omitempty"`
	LoaValue                  NullableInt32  `json:"loaValue,omitempty"`
	Id                        NullableString `json:"id,omitempty"`
	CreationTime              *time.Time     `json:"creationTime,omitempty"`
}

type _AccountProvider AccountProvider

// NewAccountProvider instantiates a new AccountProvider object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAccountProvider(displayName string, description string) *AccountProvider {
	this := AccountProvider{}
	this.DisplayName = displayName
	this.Description = description
	return &this
}

// NewAccountProviderWithDefaults instantiates a new AccountProvider object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAccountProviderWithDefaults() *AccountProvider {
	this := AccountProvider{}
	return &this
}

// GetAccountProviderIdentifier returns the AccountProviderIdentifier field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *AccountProvider) GetAccountProviderIdentifier() string {
	if o == nil || IsNil(o.AccountProviderIdentifier.Get()) {
		var ret string
		return ret
	}
	return *o.AccountProviderIdentifier.Get()
}

// GetAccountProviderIdentifierOk returns a tuple with the AccountProviderIdentifier field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *AccountProvider) GetAccountProviderIdentifierOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.AccountProviderIdentifier.Get(), o.AccountProviderIdentifier.IsSet()
}

// HasAccountProviderIdentifier returns a boolean if a field has been set.
func (o *AccountProvider) HasAccountProviderIdentifier() bool {
	if o != nil && o.AccountProviderIdentifier.IsSet() {
		return true
	}

	return false
}

// SetAccountProviderIdentifier gets a reference to the given NullableString and assigns it to the AccountProviderIdentifier field.
func (o *AccountProvider) SetAccountProviderIdentifier(v string) {
	o.AccountProviderIdentifier.Set(&v)
}

// SetAccountProviderIdentifierNil sets the value for AccountProviderIdentifier to be an explicit nil
func (o *AccountProvider) SetAccountProviderIdentifierNil() {
	o.AccountProviderIdentifier.Set(nil)
}

// UnsetAccountProviderIdentifier ensures that no value is present for AccountProviderIdentifier, not even an explicit nil
func (o *AccountProvider) UnsetAccountProviderIdentifier() {
	o.AccountProviderIdentifier.Unset()
}

// GetDisplayName returns the DisplayName field value
func (o *AccountProvider) GetDisplayName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.DisplayName
}

// GetDisplayNameOk returns a tuple with the DisplayName field value
// and a boolean to check if the value has been set.
func (o *AccountProvider) GetDisplayNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.DisplayName, true
}

// SetDisplayName sets field value
func (o *AccountProvider) SetDisplayName(v string) {
	o.DisplayName = v
}

// GetDescription returns the Description field value
func (o *AccountProvider) GetDescription() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Description
}

// GetDescriptionOk returns a tuple with the Description field value
// and a boolean to check if the value has been set.
func (o *AccountProvider) GetDescriptionOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Description, true
}

// SetDescription sets field value
func (o *AccountProvider) SetDescription(v string) {
	o.Description = v
}

// GetLoaId returns the LoaId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *AccountProvider) GetLoaId() string {
	if o == nil || IsNil(o.LoaId.Get()) {
		var ret string
		return ret
	}
	return *o.LoaId.Get()
}

// GetLoaIdOk returns a tuple with the LoaId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *AccountProvider) GetLoaIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.LoaId.Get(), o.LoaId.IsSet()
}

// HasLoaId returns a boolean if a field has been set.
func (o *AccountProvider) HasLoaId() bool {
	if o != nil && o.LoaId.IsSet() {
		return true
	}

	return false
}

// SetLoaId gets a reference to the given NullableString and assigns it to the LoaId field.
func (o *AccountProvider) SetLoaId(v string) {
	o.LoaId.Set(&v)
}

// SetLoaIdNil sets the value for LoaId to be an explicit nil
func (o *AccountProvider) SetLoaIdNil() {
	o.LoaId.Set(nil)
}

// UnsetLoaId ensures that no value is present for LoaId, not even an explicit nil
func (o *AccountProvider) UnsetLoaId() {
	o.LoaId.Unset()
}

// GetLoaValue returns the LoaValue field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *AccountProvider) GetLoaValue() int32 {
	if o == nil || IsNil(o.LoaValue.Get()) {
		var ret int32
		return ret
	}
	return *o.LoaValue.Get()
}

// GetLoaValueOk returns a tuple with the LoaValue field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *AccountProvider) GetLoaValueOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return o.LoaValue.Get(), o.LoaValue.IsSet()
}

// HasLoaValue returns a boolean if a field has been set.
func (o *AccountProvider) HasLoaValue() bool {
	if o != nil && o.LoaValue.IsSet() {
		return true
	}

	return false
}

// SetLoaValue gets a reference to the given NullableInt32 and assigns it to the LoaValue field.
func (o *AccountProvider) SetLoaValue(v int32) {
	o.LoaValue.Set(&v)
}

// SetLoaValueNil sets the value for LoaValue to be an explicit nil
func (o *AccountProvider) SetLoaValueNil() {
	o.LoaValue.Set(nil)
}

// UnsetLoaValue ensures that no value is present for LoaValue, not even an explicit nil
func (o *AccountProvider) UnsetLoaValue() {
	o.LoaValue.Unset()
}

// GetId returns the Id field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *AccountProvider) GetId() string {
	if o == nil || IsNil(o.Id.Get()) {
		var ret string
		return ret
	}
	return *o.Id.Get()
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *AccountProvider) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Id.Get(), o.Id.IsSet()
}

// HasId returns a boolean if a field has been set.
func (o *AccountProvider) HasId() bool {
	if o != nil && o.Id.IsSet() {
		return true
	}

	return false
}

// SetId gets a reference to the given NullableString and assigns it to the Id field.
func (o *AccountProvider) SetId(v string) {
	o.Id.Set(&v)
}

// SetIdNil sets the value for Id to be an explicit nil
func (o *AccountProvider) SetIdNil() {
	o.Id.Set(nil)
}

// UnsetId ensures that no value is present for Id, not even an explicit nil
func (o *AccountProvider) UnsetId() {
	o.Id.Unset()
}

// GetCreationTime returns the CreationTime field value if set, zero value otherwise.
func (o *AccountProvider) GetCreationTime() time.Time {
	if o == nil || IsNil(o.CreationTime) {
		var ret time.Time
		return ret
	}
	return *o.CreationTime
}

// GetCreationTimeOk returns a tuple with the CreationTime field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AccountProvider) GetCreationTimeOk() (*time.Time, bool) {
	if o == nil || IsNil(o.CreationTime) {
		return nil, false
	}
	return o.CreationTime, true
}

// HasCreationTime returns a boolean if a field has been set.
func (o *AccountProvider) HasCreationTime() bool {
	if o != nil && !IsNil(o.CreationTime) {
		return true
	}

	return false
}

// SetCreationTime gets a reference to the given time.Time and assigns it to the CreationTime field.
func (o *AccountProvider) SetCreationTime(v time.Time) {
	o.CreationTime = &v
}

func (o AccountProvider) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AccountProvider) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.AccountProviderIdentifier.IsSet() {
		toSerialize["accountProviderIdentifier"] = o.AccountProviderIdentifier.Get()
	}
	toSerialize["displayName"] = o.DisplayName
	toSerialize["description"] = o.Description
	if o.LoaId.IsSet() {
		toSerialize["loaId"] = o.LoaId.Get()
	}
	if o.LoaValue.IsSet() {
		toSerialize["loaValue"] = o.LoaValue.Get()
	}
	if o.Id.IsSet() {
		toSerialize["id"] = o.Id.Get()
	}
	if !IsNil(o.CreationTime) {
		toSerialize["creationTime"] = o.CreationTime
	}
	return toSerialize, nil
}

func (o *AccountProvider) UnmarshalJSON(data []byte) (err error) {
	// This validates that all required properties are included in the JSON object
	// by unmarshalling the object into a generic map with string keys and checking
	// that every required field exists as a key in the generic map.
	requiredProperties := []string{
		"displayName",
		"description",
	}

	allProperties := make(map[string]interface{})

	err = json.Unmarshal(data, &allProperties)

	if err != nil {
		return err
	}

	for _, requiredProperty := range requiredProperties {
		if _, exists := allProperties[requiredProperty]; !exists {
			return fmt.Errorf("no value given for required property %v", requiredProperty)
		}
	}

	varAccountProvider := _AccountProvider{}

	decoder := json.NewDecoder(bytes.NewReader(data))
	decoder.DisallowUnknownFields()
	err = decoder.Decode(&varAccountProvider)

	if err != nil {
		return err
	}

	*o = AccountProvider(varAccountProvider)

	return err
}

type NullableAccountProvider struct {
	value *AccountProvider
	isSet bool
}

func (v NullableAccountProvider) Get() *AccountProvider {
	return v.value
}

func (v *NullableAccountProvider) Set(val *AccountProvider) {
	v.value = val
	v.isSet = true
}

func (v NullableAccountProvider) IsSet() bool {
	return v.isSet
}

func (v *NullableAccountProvider) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAccountProvider(val *AccountProvider) *NullableAccountProvider {
	return &NullableAccountProvider{value: val, isSet: true}
}

func (v NullableAccountProvider) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAccountProvider) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
